---
title: XRRigidTransform.position
slug: Web/API/XRRigidTransform/position
tags:
  - 3D
  - API
  - AR
  - Coordinates
  - Location
  - Point
  - Position
  - Property
  - Reference
  - VR
  - WebXR
  - WebXR API
  - XR
  - XRRigidTransform
  - transform
---
<p>{{APIRef("WebXR Device API")}}</p>

<p>The read-only {{domxref("XRRigidTransform")}} property <strong><code>position</code></strong> is a {{domxref("DOMPointReadOnly")}} object which provides the 3D point, specified in meters, describing the translation component of the transform.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>pos</em> = <em>xrRigidTransform</em>.position;</pre>

<h3 id="Value">Value</h3>

<p>A read-only {{domxref("DOMPointReadOnly")}} indicating the 3D position component of the transform matrix. The units are meters.</p>

<div class="notecard note">
<p><strong>Note:</strong> The <code>w</code> component of the point is always 1.0.</p>
</div>

<h2 id="Example">Example</h2>

<p>To create a reference space which can be used to place an object at eye level (assuming eye level is 1.5 meters):</p>

<pre class="brush: js">function onSessionStarted(xrSession) {
  xrSession.addEventListener("end", onSessionEnded);

  gl = initGraphics(xrSession);

  let glLayer = new XRWebGLLayer(xrSession, gl);
  xrSession.updateRenderState({ baseLayer: glLayer });

  if (immersiveSession) {
    xrSession.requestReferenceSpace("bounded-floor").then((refSpace) =&gt; {
      refSpaceCreated(refSpace);
    }).catch(() =&gt; {
      session.requestReferenceSpace("local-floor").then(refSpaceCreated);
    });
  } else {
    session.requestReferenceSpace("viewer").then(refSpaceCreated);
  }
}

function refSpaceCreated(refSpace) {
  if (immersiveSession) {
    xrReferenceSpace = refSpace;
  } else {
    xrReferenceSpace = refSpace.getOffsetReferenceSpace(
      new XRRigidTransform({y: -1.5});
    );
  }
  xrSession.requestAnimationFrame(onFrame);
}
</pre>

<p>After setting up the graphics context for WebXR use, this begins by looking to see if a variable <code>immersiveSession</code> is <code>true</code>; if so, we first request a <code>bounded-floor</code> reference space. if that fails (probably because <code>bounded-floor</code> isn't supported), we try requesting a <code>local-floor</code> reference space.</p>

<p>If we're not in an immersive session, we instead request a <code>viewer</code> reference space.</p>

<p>In all cases, once the space has been obtained, it gets passed into the <code>refSpaceCreated()</code> function. For immersive spaces, the specified space is saved for future use. However, for inline sesions, we know we're in a space not automatically adjusted for floor level, so we request an offset reference space to shift the viewer's height to 1.5 meters above the presumed floor level of 0 meters. That new reference space is used instead of the one initially received.</p>

<p>Finally, an animation frame request is submitted.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrrigidtransform-position","XRRigidTransform.position")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRRigidTransform.position")}}</div>
